<template>
  <div>
    <b-card
      no-body
      class="mb-0"
    >
    
      <div class="row">
        <div class="col">
           
          <b-form
            class="p-5"
            @submit.stop.prevent

          >
            <h3>Editar detalles</h3>
            <b-form-group
              label="Descripción"
              label-for="description"
              title="Editar avance de actividad"
              
            >
              <b-form-input
                id="description"
                autocomplete="off"
                v-model="formData.description"
                :state="validationDescription"
                placeholder="Descripción"
              />
              <b-alert variant="warning" :show="showAlert">La descripción es obligatoria!</b-alert>
              <b-form-invalid-feedback :state="validationDescription">
                    La descripción requiere de 10 caracteres como mínimo.
              </b-form-invalid-feedback>
            </b-form-group>

            <b-form-group
              label="Comentarios"
              label-for="comments"
     
            >
                <b-form-input
                  id="comments"
                  autocomplete="off"
                  v-model="formData.comments"
                  placeholder="Comentarios"
                />
            </b-form-group>

            <b-form-group
              label="Duración del avance (horas)"
              label-for="time"
         
            >
                
              <b-form-input
                id="time"
                v-model="formData.time"
                type="number"
                onKeyUp=" if (this.value.length > 4) this.value = this.value.slice(0, 4)"
                placeholder="Duración del avance (horas)"
              />
              <b-form-invalid-feedback :state="validationTime">
                La duración del avance debe ser mayor a 0 
              </b-form-invalid-feedback>
            </b-form-group>

            <b-form-group
              label="Archivos"
              label-for="files"      
            >
                  <b-form-file
                    id="files"
                    v-model="formData.files"
                    placeholder="Seleccionar archivos..."
                    drop-placeholder="Drop file here..."
                    multiple
                  />
            </b-form-group>


            <b-button  variant="primary" @click="submit"  class="ml-1" :disabled="lockedSubmit.description || lockedSubmit.time">
                Guardar
            </b-button>
              <b-button  variant="outline-secondary" @click="$router.back()"  class="ml-1">
                Cancelar
            </b-button>
          </b-form>
        </div>
        <div class="col">
          
          <ul class="list-group p-5">
            <h3>Quitar documentos</h3>
            <li class="list-group-item list-group-item-dark">
              Documentos:
            </li>
              <li class="list-group-item list-group-item-light" v-for="(document, idx) in documents" :key="idx" >
                  <a target="_blank" :href="baseURL+document.file">{{document.file_name}}</a>
                  <b-button variant="outline" @click="deleteDocument(document.id)" ><feather-icon icon="Trash2Icon" /></b-button>         
              </li>
          </ul>

        </div>
      </div>
    </b-card>

  </div>
    
</template>

<script>
import BCardCode from '@core/components/b-card-code'
import {
  BButton, BModal, VBModal,BAlert, BForm, BFormInput, BFormGroup, BCardText,BFormDatepicker, 
  BFormFile,BFormSpinbutton,BFormInvalidFeedback, BCard
} from 'bootstrap-vue'
import Ripple from 'vue-ripple-directive'
import { ValidationProvider } from 'vee-validate';
export default {
  name:'advance-edit',
  components: {
    BFormFile,
    BCardCode,
    BButton,
    BModal,
    BForm,
    BFormInput,
    BCardText,
    BAlert,
    BFormGroup,
    BFormDatepicker,
    BFormSpinbutton,
    BFormInvalidFeedback,
    BCard
  },
  directives: {
    'b-modal': VBModal,
    Ripple,
  },
  data() {
    return {
        formData:{
            id:'',
            description:'',
            comments:'',
            time:0,
            percentage_advance:0,
            files:[],
        },
        documents:[],
        hasWrittenDescription:false,
        showAlert:false,
        baseURL:'http://quantumdaily-back.test/storage/',
        activitieManager:'',
        lockedSubmit:{
          description:true,
          time:true
        }

    }
  },
  methods:{
      submit(){
        if(this.formData.description===''){
          this.showAlert=true
          return
       }else{
          let alert
          
          alert = this.$swal({
              
              title: '¿Está seguro de guardar el avance?',
              text: "!Los detalles del avance seran actualizados!",
              icon: 'warning',
              showCancelButton: true,
              confirmButtonText: 'Si, guardar!',
              customClass: {
                confirmButton: 'btn btn-primary',
                cancelButton: 'btn btn-outline-danger ml-1',
              },
              buttonsStyling: false,

          })      
          alert.then(result => {
            if (result.value) {

                let datos = new FormData();
                datos.append("id", this.formData.id);
                datos.append("description", this.formData.description);
                datos.append("comments", this.formData.comments);
                datos.append("time", this.formData.time);
                datos.append("percentage_advance", this.formData.percentage_advance);
                for (let i=0; i<this.formData.files.length;i++){
                  datos.append('file[]', this.formData.files[i]);
                }

                const config = { headers: { "Content-Type": "multipart/form-data" } };
              
                this.$http.post("project/activities/edit/advance", datos,config).then((res) => {
                      this.$swal({
                          icon: 'success',
                          title: 'Guardado!',
                          text: 'El avance ha sido registrado correctamente.',
                          customClass: {
                            confirmButton: 'btn btn-success',
                          },
                      })

                      if (res.data.message === "agregado") {
                        this.$router.push({name:'apps-activitie-advances-view',params:{advance:this.$route.params.advance}})

                      }
                }).catch((err) => {
                    console.log(err);
                });

              } else {
              this.$swal({
                title: 'Cancelado',
                text: 'El registro no ha sido guardado',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            }
          })
        }


        
      },
      getAdvanceData(){
        this.$http.get('activitie/advances/show',{params:{advance:this.$route.params.advance}}).then(res=>{
          this.formData.id = res.data.advance.id
          this.formData.description = res.data.advance.description
          this.formData.comments= res.data.advance.comments
          this.formData.time = res.data.advance.time
          this.activitieManager = res.data.advance.activitie.manager_id
          this.beforeEnter()

        }).catch(err=>{
          console.log(err)
        })
      },
      getDocuments(){
        this.$http.get('project/activities/advances/documents',{params:{advance:this.$route.params.advance}}).then(res=>{
          this.documents = res.data.documents
        }).catch(err=>{
          console.log(err)
        })
      },
      deleteDocument(documentId){
        let alert
        
        alert = this.$swal({
            
            title: '¿Está seguro que desea eliminar el documento?',
            text: "!Esto no podrá deshacerse!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'Si, guardar!',
            customClass: {
              confirmButton: 'btn btn-primary',
              cancelButton: 'btn btn-outline-danger ml-1',
            },
            buttonsStyling: false,

        })      
        alert.then(result => {
          if (result.value) {

            this.$http.get('project/activities/advances/documents/delete',{params:{document:documentId}}).then(res=>{
              this.$swal({
                  icon: 'success',
                  title: 'Eliminado!',
                  text: 'El documento ha sido eliminado correctamente.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
              })
              this.getDocuments()
            }).catch(err=>{
              console.log(err)
            })


            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'El documento está a salvo.',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
      

      },
      beforeEnter(){
        let userData = JSON.parse(localStorage.userData)
        if ((this.hasPermission('edit_project_activities') || userData.id === this.activitieManager )) {
          return true
        }else {
          this.$router.push({name: "misc-not-authorized"}) 
        }
        
        
      }
 

  },
  computed:{
    validationDescription() {
        if (this.formData.description.length > 9){
          this.lockedSubmit.description = false
          return true
        }else{
          this.lockedSubmit.description = true
          return false
        }
      },
    validationTime() {      
      if (this.formData.time> 0){
        this.lockedSubmit.time = false
        return true
      }else{
        this.lockedSubmit.time = true
        return false
      }
        
    },
  },
  mounted(){
    this.getAdvanceData()
    this.getDocuments()
  }

}
</script>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
